#!/usr/bin/env perl

use strict;
use CGI;
use CGI::Carp qw ( fatalsToBrowser );
use File::Basename;


$CGI::APPEND_QUERY_STRING = 1;

my $safe_filename_characters = "a-zA-Z0-9_.-";
my $upload_dir = "/ftp/incoming";

my $query = CGI->new();
my $operation = $query->param("operation");

sub safe_path {
    my $path=$_[0];
    if ($path =~ m{^([/${safe_filename_characters}]*)$} ) {
       $path=$1;
    } else {
       return "";
    }
    return "/ftp/$path";
}

if ($operation eq "ls") {
    my @command;
    my $sdir;
    my $dir = $query->param("dir");
    if ($sdir = safe_path($dir)) {
        print $query->header ( );
        @command = ("ls","-l",$sdir);
        system(@command);
    }
} elsif ($operation eq "download") {
    my @command;
    my $sdir;
    my $dir = $query->param("dir");
    if ($sdir = safe_path($dir)) {
        print $query->header ( );
        @command = ("cat",$sdir);
        system(@command);
    }
} elsif ($operation eq "upload") {

    my $filename = $query->param("file");

    print $query->header ( );

    if ( !$filename )
    {
    print "There was a problem uploading your photo (try a smaller file).";
    exit;
    }

    my ( $name, $path, $extension ) = fileparse ( $filename, '\..*' );
    $filename = $name . $extension;
    $filename =~ tr/ /_/;
    $filename =~ s/[^$safe_filename_characters]//g;

    if ( $filename =~ /^([$safe_filename_characters]+)$/ )
    {
    $filename = $1;
    }
    else
    {
    die "Filename contains invalid characters";
    }

    my $upload_filehandle = $query->upload("file");

    open ( UPLOADFILE, ">$upload_dir/$filename" ) or die "$!";
    binmode UPLOADFILE;

    while ( <$upload_filehandle> )
    {
    print UPLOADFILE;
    }

    close UPLOADFILE;
    print "upload successful\n";

} else {

   die("Unknown operation '${operation}'");
}

exit(0);
